const cmd = process.argv;
const path = require('path');
const ROOT = process.cwd();
const { uid, gid } = require('os').userInfo();
const SMALL_APP = path.join(ROOT, 'node_modules/bili-small-app');

const spawnSync = require('child_process').spawnSync;

console.log('[biliSapp - info] 启动编译（若编译速度缓慢，请将「npm」源切换到国内的源或者公司源）');

// 检查用户是否忽略工具判断
const _ignore_tool_check = process.argv.indexOf('ignore_tool_check') > -1;

// 子进程处理工具检查
if (!_ignore_tool_check) {
    spawnSync(`node ${path.join(SMALL_APP, 'build/build.update.js')} ${cmd.slice(2).join(' ')}`, {
        stdio: [process.stdin, process.stdout, process.stderr],
        cwd: process.cwd(),
        uid, gid,
        shell: process.env.SHELL,
    })
}

// 子进程处理小程序编译
spawnSync(`node --no-warnings ${path.join(SMALL_APP, 'build/build.core.js')} ${cmd.slice(2).join(' ')}`, {
    stdio: [process.stdin, process.stderr],
    cwd: process.cwd(),
    uid, gid,
    shell: process.env.SHELL,
})
